package cc.smtweb.system.bpm.web.design.flow;

import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.db.cache.ModelTableCache;
import cc.smtweb.framework.core.db.vo.ModelField;
import cc.smtweb.framework.core.db.vo.ModelTable;
import cc.smtweb.framework.core.mvc.service.AbstractCompService;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.mvc.service.DefaultDelHandler;
import cc.smtweb.framework.core.mvc.service.DefaultListHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.design.form.ModelFormHelper;
import cc.smtweb.system.bpm.web.engine.flow.entity.ProcInst;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Akmm at 2022/3/22 9:12
 */
@SwService
public class ModelProcService extends AbstractCompService {
    @Override
    protected AbstractHandler createHandler(String type) {
        switch (type) {
            case TYPE_LOAD:
                return new ModelProcLoadHandler();
            case TYPE_SAVE:
                return new ModelProcSaveHandler();
            case TYPE_DEL:
                return new DefaultDelHandler<ModelProc>(ModelProc.ENTITY_NAME);
            case TYPE_LIST:
                return new DefaultListHandler<ModelProc>(ModelProc.ENTITY_NAME);

        }
        return null;
    }

    //保存页面模型
    public R saveModel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_SAVE, handler -> ((ModelProcSaveHandler)handler).saveModel());
    }

    //加载页面模型
    public R loadModel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_LOAD, handler -> ((ModelProcLoadHandler)handler).loadModel());
    }

    //加载工作流的列表字段
    public R loadProcInstFields(@SwBody SwMap params, UserSession us) {
        ModelTable table = ModelTableCache.getInstance().get(ProcInst.ENTITY_NAME);
        if (table == null) return R.error("没有找到表定义信息(table=" + ProcInst.ENTITY_NAME + ")！");

        List<SwMap> ret = new ArrayList<>();
        for (ModelField field : table.getFields()) {
            SwMap col = new SwMap(2);
            ModelFormHelper.buildFieldInfo(table, field, col);
            ret.add(col);
        }
        
        return R.success(ret);
    }
    
}
